// @generated by protobuf-ts 2.9.4
// @generated from protobuf file "game_stats.proto" (package "gamestats", syntax proto3)
// tslint:disable
import { ServiceType } from "@protobuf-ts/runtime-rpc";
import type { BinaryWriteOptions } from "@protobuf-ts/runtime";
import type { IBinaryWriter } from "@protobuf-ts/runtime";
import { WireType } from "@protobuf-ts/runtime";
import type { BinaryReadOptions } from "@protobuf-ts/runtime";
import type { IBinaryReader } from "@protobuf-ts/runtime";
import { UnknownFieldHandler } from "@protobuf-ts/runtime";
import type { PartialMessage } from "@protobuf-ts/runtime";
import { reflectionMergePartial } from "@protobuf-ts/runtime";
import { MessageType } from "@protobuf-ts/runtime";
/**
 * @generated from protobuf message gamestats.TeamStats
 */
export interface TeamStats {
    /**
     * @generated from protobuf field: int32 goals = 1;
     */
    goals: number;
    /**
     * @generated from protobuf field: int32 shots_on_target = 2;
     */
    shotsOnTarget: number;
    /**
     * @generated from protobuf field: int32 corners = 3;
     */
    corners: number;
    /**
     * @generated from protobuf field: int32 yellow_cards = 4;
     */
    yellowCards: number;
    /**
     * @generated from protobuf field: int32 red_cards = 5;
     */
    redCards: number;
    /**
     * @generated from protobuf field: string team_name = 6;
     */
    teamName: string;
}
/**
 * @generated from protobuf message gamestats.GameMetadata
 */
export interface GameMetadata {
    /**
     * @generated from protobuf field: string team_a_name = 1;
     */
    teamAName: string;
    /**
     * @generated from protobuf field: string team_b_name = 2;
     */
    teamBName: string;
    /**
     * @generated from protobuf field: int32 time_played = 3;
     */
    timePlayed: number;
    /**
     * @generated from protobuf field: int32 extra_time = 4;
     */
    extraTime: number;
}
/**
 * @generated from protobuf message gamestats.CombinedGameStats
 */
export interface CombinedGameStats {
    /**
     * @generated from protobuf field: gamestats.TeamStats team_a_stats = 1;
     */
    teamAStats?: TeamStats;
    /**
     * @generated from protobuf field: gamestats.TeamStats team_b_stats = 2;
     */
    teamBStats?: TeamStats;
    /**
     * @generated from protobuf field: gamestats.GameMetadata game_metadata = 3;
     */
    gameMetadata?: GameMetadata;
}
/**
 * @generated from protobuf message gamestats.EmptyRequest
 */
export interface EmptyRequest {
}
// @generated message type with reflection information, may provide speed optimized methods
class TeamStats$Type extends MessageType<TeamStats> {
    constructor() {
        super("gamestats.TeamStats", [
            { no: 1, name: "goals", kind: "scalar", T: 5 /*ScalarType.INT32*/ },
            { no: 2, name: "shots_on_target", kind: "scalar", T: 5 /*ScalarType.INT32*/ },
            { no: 3, name: "corners", kind: "scalar", T: 5 /*ScalarType.INT32*/ },
            { no: 4, name: "yellow_cards", kind: "scalar", T: 5 /*ScalarType.INT32*/ },
            { no: 5, name: "red_cards", kind: "scalar", T: 5 /*ScalarType.INT32*/ },
            { no: 6, name: "team_name", kind: "scalar", T: 9 /*ScalarType.STRING*/ }
        ]);
    }
    create(value?: PartialMessage<TeamStats>): TeamStats {
        const message = globalThis.Object.create((this.messagePrototype!));
        message.goals = 0;
        message.shotsOnTarget = 0;
        message.corners = 0;
        message.yellowCards = 0;
        message.redCards = 0;
        message.teamName = "";
        if (value !== undefined)
            reflectionMergePartial<TeamStats>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: TeamStats): TeamStats {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* int32 goals */ 1:
                    message.goals = reader.int32();
                    break;
                case /* int32 shots_on_target */ 2:
                    message.shotsOnTarget = reader.int32();
                    break;
                case /* int32 corners */ 3:
                    message.corners = reader.int32();
                    break;
                case /* int32 yellow_cards */ 4:
                    message.yellowCards = reader.int32();
                    break;
                case /* int32 red_cards */ 5:
                    message.redCards = reader.int32();
                    break;
                case /* string team_name */ 6:
                    message.teamName = reader.string();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: TeamStats, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* int32 goals = 1; */
        if (message.goals !== 0)
            writer.tag(1, WireType.Varint).int32(message.goals);
        /* int32 shots_on_target = 2; */
        if (message.shotsOnTarget !== 0)
            writer.tag(2, WireType.Varint).int32(message.shotsOnTarget);
        /* int32 corners = 3; */
        if (message.corners !== 0)
            writer.tag(3, WireType.Varint).int32(message.corners);
        /* int32 yellow_cards = 4; */
        if (message.yellowCards !== 0)
            writer.tag(4, WireType.Varint).int32(message.yellowCards);
        /* int32 red_cards = 5; */
        if (message.redCards !== 0)
            writer.tag(5, WireType.Varint).int32(message.redCards);
        /* string team_name = 6; */
        if (message.teamName !== "")
            writer.tag(6, WireType.LengthDelimited).string(message.teamName);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message gamestats.TeamStats
 */
export const TeamStats = new TeamStats$Type();
// @generated message type with reflection information, may provide speed optimized methods
class GameMetadata$Type extends MessageType<GameMetadata> {
    constructor() {
        super("gamestats.GameMetadata", [
            { no: 1, name: "team_a_name", kind: "scalar", T: 9 /*ScalarType.STRING*/ },
            { no: 2, name: "team_b_name", kind: "scalar", T: 9 /*ScalarType.STRING*/ },
            { no: 3, name: "time_played", kind: "scalar", T: 5 /*ScalarType.INT32*/ },
            { no: 4, name: "extra_time", kind: "scalar", T: 5 /*ScalarType.INT32*/ }
        ]);
    }
    create(value?: PartialMessage<GameMetadata>): GameMetadata {
        const message = globalThis.Object.create((this.messagePrototype!));
        message.teamAName = "";
        message.teamBName = "";
        message.timePlayed = 0;
        message.extraTime = 0;
        if (value !== undefined)
            reflectionMergePartial<GameMetadata>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: GameMetadata): GameMetadata {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* string team_a_name */ 1:
                    message.teamAName = reader.string();
                    break;
                case /* string team_b_name */ 2:
                    message.teamBName = reader.string();
                    break;
                case /* int32 time_played */ 3:
                    message.timePlayed = reader.int32();
                    break;
                case /* int32 extra_time */ 4:
                    message.extraTime = reader.int32();
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: GameMetadata, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* string team_a_name = 1; */
        if (message.teamAName !== "")
            writer.tag(1, WireType.LengthDelimited).string(message.teamAName);
        /* string team_b_name = 2; */
        if (message.teamBName !== "")
            writer.tag(2, WireType.LengthDelimited).string(message.teamBName);
        /* int32 time_played = 3; */
        if (message.timePlayed !== 0)
            writer.tag(3, WireType.Varint).int32(message.timePlayed);
        /* int32 extra_time = 4; */
        if (message.extraTime !== 0)
            writer.tag(4, WireType.Varint).int32(message.extraTime);
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message gamestats.GameMetadata
 */
export const GameMetadata = new GameMetadata$Type();
// @generated message type with reflection information, may provide speed optimized methods
class CombinedGameStats$Type extends MessageType<CombinedGameStats> {
    constructor() {
        super("gamestats.CombinedGameStats", [
            { no: 1, name: "team_a_stats", kind: "message", T: () => TeamStats },
            { no: 2, name: "team_b_stats", kind: "message", T: () => TeamStats },
            { no: 3, name: "game_metadata", kind: "message", T: () => GameMetadata }
        ]);
    }
    create(value?: PartialMessage<CombinedGameStats>): CombinedGameStats {
        const message = globalThis.Object.create((this.messagePrototype!));
        if (value !== undefined)
            reflectionMergePartial<CombinedGameStats>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: CombinedGameStats): CombinedGameStats {
        let message = target ?? this.create(), end = reader.pos + length;
        while (reader.pos < end) {
            let [fieldNo, wireType] = reader.tag();
            switch (fieldNo) {
                case /* gamestats.TeamStats team_a_stats */ 1:
                    message.teamAStats = TeamStats.internalBinaryRead(reader, reader.uint32(), options, message.teamAStats);
                    break;
                case /* gamestats.TeamStats team_b_stats */ 2:
                    message.teamBStats = TeamStats.internalBinaryRead(reader, reader.uint32(), options, message.teamBStats);
                    break;
                case /* gamestats.GameMetadata game_metadata */ 3:
                    message.gameMetadata = GameMetadata.internalBinaryRead(reader, reader.uint32(), options, message.gameMetadata);
                    break;
                default:
                    let u = options.readUnknownField;
                    if (u === "throw")
                        throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
                    let d = reader.skip(wireType);
                    if (u !== false)
                        (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
            }
        }
        return message;
    }
    internalBinaryWrite(message: CombinedGameStats, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        /* gamestats.TeamStats team_a_stats = 1; */
        if (message.teamAStats)
            TeamStats.internalBinaryWrite(message.teamAStats, writer.tag(1, WireType.LengthDelimited).fork(), options).join();
        /* gamestats.TeamStats team_b_stats = 2; */
        if (message.teamBStats)
            TeamStats.internalBinaryWrite(message.teamBStats, writer.tag(2, WireType.LengthDelimited).fork(), options).join();
        /* gamestats.GameMetadata game_metadata = 3; */
        if (message.gameMetadata)
            GameMetadata.internalBinaryWrite(message.gameMetadata, writer.tag(3, WireType.LengthDelimited).fork(), options).join();
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message gamestats.CombinedGameStats
 */
export const CombinedGameStats = new CombinedGameStats$Type();
// @generated message type with reflection information, may provide speed optimized methods
class EmptyRequest$Type extends MessageType<EmptyRequest> {
    constructor() {
        super("gamestats.EmptyRequest", []);
    }
    create(value?: PartialMessage<EmptyRequest>): EmptyRequest {
        const message = globalThis.Object.create((this.messagePrototype!));
        if (value !== undefined)
            reflectionMergePartial<EmptyRequest>(this, message, value);
        return message;
    }
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: EmptyRequest): EmptyRequest {
        return target ?? this.create();
    }
    internalBinaryWrite(message: EmptyRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter {
        let u = options.writeUnknownFields;
        if (u !== false)
            (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
        return writer;
    }
}
/**
 * @generated MessageType for protobuf message gamestats.EmptyRequest
 */
export const EmptyRequest = new EmptyRequest$Type();
/**
 * @generated ServiceType for protobuf service gamestats.GameStats
 */
export const GameStats = new ServiceType("gamestats.GameStats", [
    { name: "UpdateGameMetadata", options: {}, I: GameMetadata, O: EmptyRequest },
    { name: "UpdateTeamStats", options: {}, I: TeamStats, O: EmptyRequest },
    { name: "UpdateCombinedGameStats", options: {}, I: CombinedGameStats, O: EmptyRequest },
    { name: "GetGameStats", options: {}, I: EmptyRequest, O: CombinedGameStats },
    { name: "MonitorGameStats", serverStreaming: true, options: {}, I: EmptyRequest, O: CombinedGameStats }
]);
